%global repo qt6platform-plugins
%global __provides_exclude_from ^%{_qt6_plugindir}/.*\\.so$

Name:           deepin-qt6platform-plugins
Version:        6.0.27
Release:        %autorelease
Summary:        Qt platform integration plugins for Deepin Desktop Environment
# main code is LGPL-3.0-or-later

# GPL-3.0-or-later:
# ./xcb/dplatformintegration.cpp
# ./xcb/dplatformintegration.h
# ./xcb/dplatformnativeinterfacehook.cpp
# ./xcb/dplatformnativeinterfacehook.h
# ./xcb/dplatformopenglcontexthelper.cpp
# ./xcb/dplatformopenglcontexthelper.h
# ./xcb/dplatformwindowhelper.cpp
# ./xcb/dplatformwindowhelper.h
# ./xcb/dplatformwindowhook.cpp
# ./xcb/dplatformwindowhook.h
# ./xcb/dwmsupport.h
# ./xcb/dxcbwmsupport.cpp
# ./xcb/dxcbwmsupport.h

# GPL-2.0-only OR GPL-3.0-or-later OR LGPL-3.0-only:
# ./src/dxcbxsettings.cpp
# ./src/dxcbxsettings.h

# not included in binary package
# ./xcb/libqt5xcbqpa-dev - LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
# ./xcb/libqt6xcbqpa-dev - LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
# ./wayland/qtwayland-dev - GPL-3.0-or-later AND (LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only)
License:        LGPL-3.0-or-later AND GPL-3.0-or-later AND (GPL-2.0-only OR GPL-3.0-or-later OR LGPL-3.0-only)
URL:            https://github.com/linuxdeepin/qt6platform-plugins
Source0:        %{url}/archive/%{version}/%{repo}-%{version}.tar.gz

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  ninja-build
BuildRequires:  extra-cmake-modules

BuildRequires:  cmake(Qt6Core)
BuildRequires:  cmake(Qt6Gui)
BuildRequires:  cmake(Qt6Widgets)
BuildRequires:  cmake(Qt6OpenGL)
BuildRequires:  cmake(Qt6XcbQpaPrivate)
BuildRequires:  qt6-qtbase-static
BuildRequires:  qt6-qtbase-private-devel
%{?_qt6:Requires: %{_qt6}%{?_isa} = %{_qt6_version}}

BuildRequires:  pkgconfig(x11-xcb)
BuildRequires:  pkgconfig(xi)
BuildRequires:  pkgconfig(xcb-renderutil)
BuildRequires:  pkgconfig(sm)
BuildRequires:  pkgconfig(ice)
BuildRequires:  pkgconfig(xcb-render)
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(xcb)
BuildRequires:  pkgconfig(xcb-image)
BuildRequires:  pkgconfig(xcb-icccm)
BuildRequires:  pkgconfig(xcb-sync)
BuildRequires:  pkgconfig(xcb-xfixes)
BuildRequires:  pkgconfig(xcb-shm)
BuildRequires:  pkgconfig(xcb-randr)
BuildRequires:  pkgconfig(xcb-shape)
BuildRequires:  pkgconfig(xcb-keysyms)
BuildRequires:  pkgconfig(xcb-xkb)
BuildRequires:  pkgconfig(xcb-composite)
BuildRequires:  pkgconfig(xkbcommon-x11)
BuildRequires:  pkgconfig(xcb-damage)
BuildRequires:  pkgconfig(xcb-xinerama)
BuildRequires:  pkgconfig(mtdev)
BuildRequires:  pkgconfig(egl)
BuildRequires:  pkgconfig(cairo)
BuildRequires:  pkgconfig(xkbcommon)

BuildRequires:  xcb-util-cursor-devel
BuildRequires:  libasan

BuildRequires:  gtest-devel
BuildRequires:  gmock-devel

%description
qt6platform-plugins is the Qt platform integration plugin for Deepin Desktop
Environment.

%prep
%autosetup -p1 -n %{repo}-%{version}

# remove redundant bundled code
rm -r xcb/{libqt5xcbqpa-dev,libqt6xcbqpa-dev}
rm -r wayland/qtwayland-dev

%build
%cmake -GNinja \
    -DDTK_VERSION=%{version} \
    -DQT_XCB_PRIVATE_HEADERS=%{_qt6_headerdir}/QtXcb \
%cmake_build

%install
%cmake_install

%files
%doc README.md
%license LICENSE
%{_qt6_plugindir}/platforms/libdxcb.so

%changelog
%autochangelog
